-----------------------------------------------------------------------
---------------------------KATTAJ1 - TTAJ1bl4--------------------------
-----------------------------------------------------------------------
------------------Copying and Redistribution is FORBIDDEN--------------
-----------------------------------------------------------------------

local function getOrCreateModData(object)
    if not object:getModData().ZRAP then
        object:getModData().ZRAP = {}
    end
    return object:getModData().ZRAP
end


local function ZRAP_setArmor(vehicle, part)
    local item = part:getInventoryItem()
    local modData, protect, ZRAP_DefenceLevel

    if part:getTable("ZRAP_Armor") then
        local ZRAP_ArmorTable = part:getTable("ZRAP_Armor")
        local partsToProtect = {ZRAP_ArmorTable.part1, ZRAP_ArmorTable.part2, ZRAP_ArmorTable.part3}

        for _, partToProtect in ipairs(partsToProtect) do
            protect = vehicle:getPartById(partToProtect)
            modData = getOrCreateModData(protect)

            if item and ZRAP_ArmorTable.ZRAP_DefenceLevels[item:getType()] then
                ZRAP_DefenceLevel = ZRAP_ArmorTable.ZRAP_DefenceLevels[item:getType()]
            else
                ZRAP_DefenceLevel = 1.0
            end
            
            if item and protect and modData.durability then 
                local ddm = (modData.durability - protect:getCondition()) 
                if protect:getCondition() < modData.durability and ddm > 6 then  
                    if part:getCondition() > 0 then 
                        
            
                        if part:getCondition() >= ddm then 
                            protect:setCondition(protect:getCondition() + ddm) 
                            part:setCondition(part:getCondition() - (ddm / ZRAP_DefenceLevel)) 
                        else 
                            protect:setCondition(protect:getCondition() + part:getCondition()) 
                            part:setCondition(0) 
                            -- part:setInventoryItem(nil); -- Removes part. May be add explosion sound ? For the future
                            -- part:getVehicle():playSound("VehicleTireExplode"); 
                        end 
                    else 
                        modData.durability = protect:getCondition() 
                    end 
                end 
            else 
                modData.durability = protect:getCondition() 
            end
            
        end
    end
end


-- 3 птм чт инч бдт лмтс снвн брн
local ZRAP_Vehicle_BaseArmor = { 
    {partName = "WindowFrontLeft", technical_condition = 100, conditionDelta = -3, threshold = -10, initialized = false}, 
    {partName = "WindowFrontRight", technical_condition = 100, conditionDelta = -3, threshold = -10, initialized = false}, 
    {partName = "WindowMiddleLeft", technical_condition = 100, conditionDelta = -3, threshold = -10, initialized = false}, 
    {partName = "WindowMiddleRight", technical_condition = 100, conditionDelta = -3, threshold = -10, initialized = false}, 
    {partName = "WindowRearLeft", technical_condition = 100, conditionDelta = -3, threshold = -10, initialized = false}, 
    {partName = "WindowRearRight", technical_condition = 100, conditionDelta = -3, threshold = -10, initialized = false}, 
    {partName = "Windshield", technical_condition = 100, conditionDelta = -3, threshold = -10, initialized = false}, 

    {partName = "DoorFrontLeft", technical_condition = 100, conditionDelta = -5, threshold = -10, initialized = false}, 
    {partName = "DoorFrontRight", technical_condition = 100, conditionDelta = -5, threshold = -10, initialized = false}, 
    {partName = "DoorRearLeft", technical_condition = 100, conditionDelta = -5, threshold = -10, initialized = false}, 
    {partName = "DoorRearRight", technical_condition = 100, conditionDelta = -5, threshold = -10, initialized = false}, 

    {partName = "EngineDoor", technical_condition = 100, conditionDelta = -4, threshold = -10, initialized = false},
    
    {partName = "TruckBed", technical_condition = 100, conditionDelta = -2, threshold = -10, initialized = false}, 
}
--[[
local ZRAP_Vehicle_BaseArmor = { 
    {partName = "WindowFrontLeft", technical_condition = 100, conditionDelta = -1, threshold = -3}, 
    {partName = "WindowFrontRight", technical_condition = 100, conditionDelta = -1, threshold = -3}, 
    {partName = "WindowMiddleLeft", technical_condition = 100, conditionDelta = -1, threshold = -3}, 
    {partName = "WindowMiddleRight", technical_condition = 100, conditionDelta = -1, threshold = -3}, 
    {partName = "WindowRearLeft", technical_condition = 100, conditionDelta = -1, threshold = -3}, 
    {partName = "WindowRearRight", technical_condition = 100, conditionDelta = -1, threshold = -3}, 
    {partName = "Windshield", technical_condition = 100, conditionDelta = -1, threshold = -3}, 

    {partName = "DoorFrontLeft", technical_condition = 100, conditionDelta = -1, threshold = -2}, 
    {partName = "DoorFrontRight", technical_condition = 100, conditionDelta = -1, threshold = -2}, 
    {partName = "DoorRearLeft", technical_condition = 100, conditionDelta = -1, threshold = -2}, 
    {partName = "DoorRearRight", technical_condition = 100, conditionDelta = -1, threshold = -2}, 

    {partName = "EngineDoor", technical_condition = 100, conditionDelta = -2, threshold = -5},
    {partName = "TruckBed", technical_condition = 100, conditionDelta = -2, threshold = -5}, 
}
]]

function ZRAP_UpdateWindowArmor(player, part, elapsedMinutes, ZRAP_Windows_ArmorData) 
    local vehicle = player:getVehicle() 

    if (vehicle and string.find(vehicle:getScriptName(), "ZRAP")) then 
        local part = vehicle:getPartById(ZRAP_Windows_ArmorData.partName) 
        local currentCondition = part:getCondition()
        
        if not ZRAP_Windows_ArmorData.initialized then
            ZRAP_Windows_ArmorData.technical_condition = currentCondition
            ZRAP_Windows_ArmorData.initialized = true
        end
        
        if (currentCondition < ZRAP_Windows_ArmorData.technical_condition + ZRAP_Windows_ArmorData.threshold) then 
            ZRAP_Windows_ArmorData.technical_condition = ZRAP_Windows_ArmorData.technical_condition + ZRAP_Windows_ArmorData.conditionDelta
            sendClientCommand(player, "vehicle", "setPartCondition", { vehicle = vehicle:getId(), part = part:getId(), condition = ZRAP_Windows_ArmorData.technical_condition }) 
        elseif (currentCondition > ZRAP_Windows_ArmorData.technical_condition) then
            ZRAP_Windows_ArmorData.technical_condition = currentCondition
        end 
        vehicle:transmitPartModData(part) 
    end 
end

for _, ZRAP_Windows_ArmorData in ipairs(ZRAP_Vehicle_BaseArmor) do
    Events.OnPlayerUpdate.Add(function(player, part, elapsedMinutes)
        ZRAP_UpdateWindowArmor(player, part, elapsedMinutes, ZRAP_Windows_ArmorData)
    end)
end


local ZRAP_TruckBedPart = "ZRAP_TruckBedPart"  
local TruckBed = "TruckBed"  

function ZRAP_SyncTruckBedCondition(player, part, elapsedMinutes)
    local vehicle = player:getVehicle()

    if (vehicle and string.find(vehicle:getScriptName(), "ZRAP")) then
        local zrapTruckBedPart = vehicle:getPartById(ZRAP_TruckBedPart)
        local truckBedPart = vehicle:getPartById(TruckBed)

        if (zrapTruckBedPart and truckBedPart) then
            local truckBedCondition = truckBedPart:getCondition()
            local zrapTruckBedCondition = zrapTruckBedPart:getCondition()

            if (zrapTruckBedCondition ~= truckBedCondition) then
                if (zrapTruckBedCondition > truckBedCondition and (zrapTruckBedCondition - truckBedCondition) > 10) then
                    local newTruckBedCondition = zrapTruckBedCondition
                    sendClientCommand(player, "vehicle", "setPartCondition", { vehicle = vehicle:getId(), part = truckBedPart:getId(), condition = newTruckBedCondition })
                else
                    sendClientCommand(player, "vehicle", "setPartCondition", { vehicle = vehicle:getId(), part = zrapTruckBedPart:getId(), condition = truckBedCondition })
                end
            end
        end
    end
end

local function ZRAP_VehicleEnter(player)
    local modData = getOrCreateModData(player)
    local vehicle = player:getVehicle()
    local ZRAP_DefenceParts = {}

    for i = 1, vehicle:getPartCount() do
        local part = vehicle:getPartByIndex(i - 1)

        if part:getTable("ZRAP_Armor") then
            table.insert(ZRAP_DefenceParts, part)
        end
    end

    modData.VehicleObject = {
        Vehicle = vehicle,
        ZRAP_ArmoredParts = ZRAP_DefenceParts
    }
end

local function ZRAP_PlayerUpdate(player)
    local vehicle = player:getVehicle()
    if not vehicle then return end

    local modData = getOrCreateModData(player)
    local vehicleObject = modData.VehicleObject

    if vehicleObject then
        if vehicleObject.Vehicle == vehicle then
            for i = 1, #vehicleObject.ZRAP_ArmoredParts do
                local part = vehicleObject.ZRAP_ArmoredParts[i]
                ZRAP_setArmor(vehicle, part)
            end
        end
    end
end

Events.OnPlayerUpdate.Add(ZRAP_SyncTruckBedCondition)
Events.OnEnterVehicle.Add(ZRAP_VehicleEnter)
Events.OnPlayerUpdate.Add(ZRAP_PlayerUpdate)
