-----------------------------------------------------------------------
---------------------------KATTAJ1 - TTAJ1bl4--------------------------
-----------------------------------------------------------------------

if not ZRAP_Vehicle then ZRAP_Vehicle = {} end
if not ZRAP_Vehicle.ContainerAccess then ZRAP_Vehicle.ContainerAccess = {} end

function ZRAP_Vehicle.ContainerAccess.ZRAP_TruckBed(vehicle, part, chr)
    if chr:getVehicle() == vehicle then
        local seat = vehicle:getSeat(chr)
        -- Check if the seated player can access the trunk storage
        -- Only characters in specific seats can access it
        if seat == 2 or seat == 3 or seat == 4 or seat == 5 then
            return true
        end
    elseif chr:getVehicle() then
        -- Can't reach from inside a different vehicle.
        return false
    else
        -- Standing outside the vehicle.
        if not vehicle:isInArea(part:getArea(), chr) then return false end
        
        local rearLeftDoor = vehicle:getPartById("DoorRearLeft")
        local rearRightDoor = vehicle:getPartById("DoorRearRight")
        
        local rearLeftDoorItem = rearLeftDoor:getInventoryItem()
        local rearRightDoorItem = rearRightDoor:getInventoryItem()

        -- Check if door installed. If not - access true
        if not rearLeftDoorItem or not rearRightDoorItem then return true end

        -- Check if at least one of the doors exists and is open
        if (rearLeftDoor and rearLeftDoor:getDoor() and rearLeftDoor:getDoor():isOpen()) or
           (rearRightDoor and rearRightDoor:getDoor() and rearRightDoor:getDoor():isOpen()) then
            return true
        end
    end
    
    return false
end




