----------------------------------------------------------------------------
----------------------------- KATTAJ1 - TTAJ1bl4 ---------------------------
----------------------------------------------------------------------------

require "Items/ProceduralDistributions"


function ZRAP_ItemDistributions(ZRAP_itemSets, ZRAP_suffixes, ZRAP_spawnChances, ZRAP_distributionNames)
    local currentIndex = 1 

    for _, distributionName in ipairs(ZRAP_distributionNames) do
        local distribution = ProceduralDistributions.list[distributionName]

        for i, itemSet in ipairs(ZRAP_itemSets) do
            local baseItem = itemSet.baseItem
            local continuation = itemSet.continuation or ""

            for _, suffix in ipairs(ZRAP_suffixes) do
                local fullItem = "Base." .. baseItem .. suffix .. continuation

                local currentSpawnChance = ZRAP_spawnChances[currentIndex]
                currentIndex = (currentIndex % #ZRAP_spawnChances) + 1

                table.insert(distribution.items, fullItem)
                table.insert(distribution.items, currentSpawnChance)
            end
        end
    end
end

 
local ZRAP_emptysuffixes = {""} 
 

--[[
local ZRAP_GasCanChances = {0.025, 0.0125, 0.0025} 
local ZRAP_ProtocolsChances = {0.05, 0.025, 0.0125, 0.0125, 0.00025} 
]]--
local ZRAP_GasCanChances = {3, 1} 
local ZRAP_ProtocolsChances = {3, 2, 1} 


local ZRAP_GasCanDistributions = {"ArmyHangarTools","ArmySurplusMisc","ArmySurplusTools","GigamartTools","CrateTools","CrateMechanics","GarageMechanics","GarageTools","GasStorageMechanics","MechanicShelfTools"} 
local ZRAP_ProtocolsDistributions = {"LockerArmyBedroom", "ArmyStorageOutfit","PoliceStorageOutfit", "PoliceLockers", "PoliceStorageGuns",} 

-- PoliceStorageOutfit
-- PoliceLockers
-- PoliceStorageGuns

-- ArmySurplusOutfit
-- LockerArmyBedroom
-- ArmyStorageOutfit
-- ArmyHangarTools
-- ArmySurplusMisc 

-- GunStoreCounter

-- GigamartTools


local ZRAP_itemSets = { 
    -- GasCans
        { baseItem = "ZRAP_GasCanEmpty2" },
        { baseItem = "ZRAP_GasCanFull2" }
} 
ZRAP_ItemDistributions(ZRAP_itemSets, ZRAP_emptysuffixes, ZRAP_GasCanChances, ZRAP_GasCanDistributions)

local ZRAP_itemSets1 = {      
    -- Protocols
        { baseItem = "ProtocolCharlie" }, 
        { baseItem = "ProtocolBravo" }, 
        { baseItem = "ProtocolAlpha" } 
    } 
ZRAP_ItemDistributions(ZRAP_itemSets1, ZRAP_emptysuffixes, ZRAP_ProtocolsChances, ZRAP_ProtocolsDistributions)


table.insert(VehicleDistributions["Police"]["TruckBed"].items, "ZRAP_GasCanEmpty2");
table.insert(VehicleDistributions["Police"]["TruckBed"].items, 3);

table.insert(VehicleDistributions["Police"]["TruckBed"].items, "ZRAP_GasCanFull2");
table.insert(VehicleDistributions["Police"]["TruckBed"].items, 1);

table.insert(VehicleDistributions["SurvivalistTruckBed"].items, "ZRAP_GasCanEmpty2");
table.insert(VehicleDistributions["SurvivalistTruckBed"].items, 3);

table.insert(VehicleDistributions["SurvivalistTruckBed"].items, "ZRAP_GasCanFull2");
table.insert(VehicleDistributions["SurvivalistTruckBed"].items, 3);

table.insert(VehicleDistributions["HunterTruckBed"].items, "ZRAP_GasCanEmpty2");
table.insert(VehicleDistributions["HunterTruckBed"].items, 3);

table.insert(VehicleDistributions["HunterTruckBed"].items, "ZRAP_GasCanFull2");
table.insert(VehicleDistributions["HunterTruckBed"].items, 1);