
if not ZRAP_ArmoredVehicle then ZRAP_ArmoredVehicle = {} end
if not ZRAP_ArmoredVehicleUtils then ZRAP_ArmoredVehicleUtils = {} end
if not ZRAP_ArmoredVehicle.Create then ZRAP_ArmoredVehicle.Create = {} end
if not ZRAP_ArmoredVehicle.Init then ZRAP_ArmoredVehicle.Init = {} end
if not ZRAP_ArmoredVehicle.InstallComplete then ZRAP_ArmoredVehicle.InstallComplete = {} end
if not ZRAP_ArmoredVehicle.UninstallComplete then ZRAP_ArmoredVehicle.UninstallComplete = {} end



function ZRAP_ArmoredVehicle.ModelByItemName(vehicle, part, item)
    if not part:getItemType() or part:getItemType():isEmpty() then
        part:setModelVisible("Default", true)
        part:setModelVisible("StaticPart", true)
    else
        if part:getTable("ZRAP_Models") then
            local modelVisibleList = {}
            if item then
                part:setModelVisible("StaticPart", true)
                for itemName, oneModel in pairs(part:getTable("ZRAP_Models")) do
                    if item:getType() == itemName then
                        part:setModelVisible(oneModel, true)
                        modelVisibleList[oneModel] = true
                    else
                        if not modelVisibleList[oneModel] then
                            part:setModelVisible(oneModel, false)
                        end
                    end
                end
            else
                part:setModelVisible("StaticPart", false)
                for itemName, oneModel in pairs(part:getTable("ZRAP_Models")) do
                    part:setModelVisible(oneModel, false)
                end
            end
        else
            if item then
                part:setModelVisible("Default", true)
                part:setModelVisible("StaticPart", true)
            else
                part:setModelVisible("Default", false)
                part:setModelVisible("StaticPart", false)
            end
        end
    end
end


function ZRAP_ArmoredVehicle.Init.DefaultModel(vehicle, part)
    ZRAP_ArmoredVehicle.ModelByItemName(vehicle, part, part:getInventoryItem())
    vehicle:transmitPartCondition(part)
    vehicle:transmitPartItem(part)
    vehicle:doDamageOverlay()
end

function ZRAP_ArmoredVehicle.InstallComplete.DefaultModel(vehicle, part)
    ZRAP_ArmoredVehicle.ModelByItemName(vehicle, part, part:getInventoryItem())
    vehicle:doDamageOverlay()
end

function ZRAP_ArmoredVehicle.UninstallComplete.DefaultModel(vehicle, part, item)
    ZRAP_ArmoredVehicle.ModelByItemName(vehicle, part)
    vehicle:doDamageOverlay()
end


function ZRAP_ArmoredVehicle.Create.Tire(vehicle, part)
    Vehicles.Create.Tire(vehicle, part)
    ZRAP_ArmoredVehicle.ModelByItemName(vehicle, part, part:getInventoryItem())
end

function ZRAP_ArmoredVehicle.Init.Tire(vehicle, part)
    Vehicles.Init.Tire(vehicle, part)
    ZRAP_ArmoredVehicle.ModelByItemName(vehicle, part, part:getInventoryItem())
end

function ZRAP_ArmoredVehicle.InstallComplete.Tire(vehicle, part)
    Vehicles.InstallComplete.Tire(vehicle, part)
    ZRAP_ArmoredVehicle.ModelByItemName(vehicle, part, part:getInventoryItem())
end

function ZRAP_ArmoredVehicle.UninstallComplete.Tire(vehicle, part, item)
    Vehicles.UninstallComplete.Tire(vehicle, part, item)
    ZRAP_ArmoredVehicle.ModelByItemName(vehicle, part)
end





